var rawModels = ModelManager.loadPartedRawModel(Resources.manager(), Resources.idRelative("mtrsteamloco:eyecandies/billboard/board.obj"), null);
var models = uploadPartedCandyModels(rawModels, true);


const standAdsCount = 10;
// Для расширения кол-ва реклам: просто увеличьте переменную и загрузите в папку скриншоты до нужного числа в папке ads
const useJPG = true;
// использовать ли JPG

const ads1 = generateAds(models["ad1"], standAdsCount)
const ads2 = generateAds(models["ad2"], standAdsCount)

function create(ctx, state, entity) {

}

function dispose(ctx, state, entity) {
	
}


function render(ctx, state, entity) {
	var matrices = new Matrices();
	ctx.drawModel(models["main"], matrices);

	let seed = entity.getWorldPosVector3f().z() + entity.getWorldPosVector3f().x();
	seed = Math.abs(seed)
	let seed2 = entity.getWorldPosVector3f().z() - entity.getWorldPosVector3f().x();
	seed2 = Math.abs(seed2)
	let random = seed % standAdsCount;
	let random2 = seed2 % standAdsCount;

	ctx.drawModel(ads1[random], matrices);
	ctx.drawModel(ads2[random2], matrices);
}

function generateAds(model, standAdsCount) {
	let result = [];
	for (var i = 1; i <= standAdsCount; i++) {
		let copy =  model.copyForMaterialChanges();
		let end = useJPG ? ".jpg" : ".png";
		copy.replaceAllTexture(Resources.idRelative("mtrsteamloco:eyecandies/billboard/ads/"+i+end));
		result[i-1] = copy;
	}
	return result; 
}


function uploadPartedCandyModels(rawModels, invertV) { 
	result = {};
	for (it = rawModels.entrySet().iterator(); it.hasNext(); ) {
		entry = it.next();

		let jsStringKey = "" + entry.getKey(); // строка в жс строку
		if (jsStringKey.includes("int") || jsStringKey.includes("doorm")) entry.getValue().setAllRenderType("interior"); //включение интерьера
		if (jsStringKey.includes("lights")) entry.getValue().setAllRenderType("light"); //включение света
		if (jsStringKey.includes("translucent")) entry.getValue().setAllRenderType("exteriortranslucent"); 

		entry.getValue().applyUVMirror(false, invertV);
		result[jsStringKey] = ModelManager.uploadVertArrays(entry.getValue());
	}
	return result;
}
