var rawModels = ModelManager.loadPartedRawModel(Resources.manager(), Resources.idRelative("mtrsteamloco:eyecandies/bus_stop_1/msk_bus_stop.obj"), null);
var models = uploadPartedCandyModels(rawModels, true);

const standAdsCount = 3;
// Для расширения кол-ва реклам: просто увеличьте переменную и загрузите в папку скриншоты до нужного числа в папке ads
const useJPG = true;
// использовать ли JPG

const ads = generateAds(models["ads"], standAdsCount)

function create(ctx, state, entity) {

}

function dispose(ctx, state, entity) {
	
}


function render(ctx, state, entity) {
	var matrices = new Matrices();
	ctx.drawModel(models["main"], matrices);
	ctx.drawModel(models["translucent"], matrices);

	let xzSum = entity.getWorldPosVector3f().z()+entity.getWorldPosVector3f().x();
	xzSum = Math.abs(xzSum);
	let random = xzSum % standAdsCount;

	ctx.drawModel(ads[random], matrices);
}

function generateAds(model, standAdsCount) {
	let result = [];
	for (var i = 1; i <= standAdsCount; i++) {
		let copy =  model.copyForMaterialChanges();
		let end = useJPG ? ".jpg" : ".png";
		copy.replaceAllTexture(Resources.idRelative("mtrsteamloco:eyecandies/bus_stop_1/ads/"+i+end));
		result[i-1] = copy;
	}
	return result; 
}


function uploadPartedCandyModels(rawModels, invertV) { 
	result = {};
	for (it = rawModels.entrySet().iterator(); it.hasNext(); ) {
		entry = it.next();

		let jsStringKey = "" + entry.getKey(); // строка в жс строку
		if (jsStringKey.includes("int") || jsStringKey.includes("doorm")) entry.getValue().setAllRenderType("interior"); //включение интерьера
		if (jsStringKey.includes("lights")) entry.getValue().setAllRenderType("light"); //включение света
		if (jsStringKey.includes("translucent")) entry.getValue().setAllRenderType("exteriortranslucent"); 

		entry.getValue().applyUVMirror(false, invertV);
		result[jsStringKey] = ModelManager.uploadVertArrays(entry.getValue());
	}
	return result;
}
