var rawModels = ModelManager.loadPartedRawModel(Resources.manager(), 
	Resources.idRelative("mtrsteamloco:eyecandies/escalator/escalator3.obj"), null);
var models = uploadPartedCandyModels(rawModels, true);

function create(ctx, state, entity) {
}

function dispose(ctx, state, entity) {
}


function render(ctx, state, entity, matrices) {
	var matrices = new Matrices();
	ctx.drawModel(models["main"], matrices);
	drawStairs(ctx, state, entity, matrices);
}

function drawStairs(ctx, state, entity, matrices) {
	const stairsStartZ = 0;
	const stairsEndZ = 4;
	
	const escalatorOffset = 0.1665;
	const offsetOfCalculating = 0.1665;

	const escalatorCount = 13;

	let stairDelta = (stairsEndZ - stairsStartZ) / (escalatorCount - 1);

	const stairShiftTime = 500; // ms

	let timeElapsedInMS = Math.floor(Timing.elapsed() * 1000);
	let timeDeltaCoef = (timeElapsedInMS % stairShiftTime) * 1.0 / stairShiftTime;

	
	for (let i = 0; i < escalatorCount; i++) {

		let shiftTimeDelta = timeDeltaCoef * stairDelta;
		let z = -(i * stairDelta + stairsStartZ + escalatorOffset + shiftTimeDelta);
		let y = escalatorFunc(-(z - offsetOfCalculating));

		matrices.pushPose();
		matrices.translate(0, y, z);
		ctx.drawModel(models["stair"], matrices);
		matrices.popPose();
	}

}

function escalatorFunc(x) {
	if (x < 2.5) return 0.666 * x;
	if (x < 3.5) return -0.333*x*x + 2.333*x - 2.083;
	return 2;	
}



function uploadPartedCandyModels(rawModels, invertV) { 
	result = {};
	for (it = rawModels.entrySet().iterator(); it.hasNext(); ) {
		entry = it.next();

		let jsStringKey = "" + entry.getKey(); // строка в жс строку
		if (jsStringKey == "int" || jsStringKey.includes("doorm")) entry.getValue().setAllRenderType("interior"); //включение интерьера
		if (jsStringKey == "lights") entry.getValue().setAllRenderType("light"); //включение света
		if (jsStringKey == "translucent") entry.getValue().setAllRenderType("exteriortranslucent"); 

		entry.getValue().applyUVMirror(false, invertV);
		result[jsStringKey] = ModelManager.uploadVertArrays(entry.getValue());
	}
	return result;
}
