var rawModels = ModelManager.loadPartedRawModel(Resources.manager(), Resources.idRelative("mtrsteamloco:eyecandies/stand/pc_stand.obj"), null);
var models = uploadPartedModels(rawModels);

function create(ctx, state, entity) {
	state.isOpen = MinecraftClient.worldDayTime() < 13000;
	// entity.doorCoef = entity.isClosed ? 1.0 : 0.0; Matrices.size() is not implemented yet
}

function dispose(ctx, state, entity) {
	
}


function render(ctx, state, entity) {
	var matrices = new Matrices();
	ctx.drawModel(models["ext"], matrices);

	renderClosingDoor(ctx, state, matrices)
	updateDoor(ctx, state);
}

function updateDoor(ctx, state) {
	state.isOpen = MinecraftClient.worldDayTime() % 24000 < 13000;
}

function renderClosingDoor(ctx, state, matrices) {
	// matrices.push();
	
	// matrices.translate(0.0, -2.69, 0.0);
	if (!state.isOpen) {
		ctx.drawModel(models["win"], matrices);
	}
}

function uploadPartedModels(rawModels) { 
	result = {};
	for (it = rawModels.entrySet().iterator(); it.hasNext(); ) {
		entry = it.next();

		let jsStringKey = "" + entry.getKey(); // строка в жс строку
		if (jsStringKey == "int" || jsStringKey.includes("doorm")) entry.getValue().setAllRenderType("interior"); //включение интерьера
		if (jsStringKey == "lights") entry.getValue().setAllRenderType("light"); //включение света

		entry.getValue().applyUVMirror(false, true);
		result[jsStringKey] = ModelManager.uploadVertArrays(entry.getValue());
	}
	return result;
}